#include <stdio.h>
#include "listapi.h"

/* Search for a node by its key d */
node * search(node * head, int d) 
{
  for(; head != NULL; head = head->next)
    if ( head -> data == d)  return head;
  return NULL;
}

/* insert a node into list */
node * add(node * head, int d) {
  node * loc;
  loc=search(head, d );
  if (loc != NULL) return head;  /* No need to change */
  else {
    node * newhead;
    newhead = (node *) malloc( sizeof(node) );
    newhead -> data = d;
    newhead -> next= head;
    return newhead;
  }
}

void free_list(node *head)
{
  node *p = head;
  while (p != NULL) {
    head = head ->next;
    free(p);
    p = head;
  }
  
}
