/* Tests whether a number is prime or not */

#include <stdio.h>

const int TRUE=1;
const int FALSE=0;

typedef int Bool;

/* is_prime(n) returns TRUE if n is prime, *
 * FALSE otherwise. */

Bool is_prime(int n)
{
  int divisor;

  if (n <= 1) return FALSE;
  for (divisor=2; divisor * divisor <= n; divisor++)
    if (n % divisor == 0)
      return FALSE;
  return TRUE;
}
	
int main()
{
  int n;
  printf("Enter an integer number: ");
  scanf("%d", &n);
  if (is_prime(n))
    printf("Prime \n");
  else
    printf("Not prime \n");

  return 0;
}
