#include <stdio.h>
#include <stdlib.h>
/* Print out all prime 
numbers which are less 
than m */
/*  Le crible d' Eratosthne   */

void print_prime( int m )
{
  int i,j;
  int * ary = (int *)  malloc( m * sizeof(int));
  if (ary==NULL) exit -1;
  for(i=0;i<m;i++)
    ary[i]=1;
  /* Assume all integers between 0 and m-1 are prime */
  ary[0]=ary[1]=0;    
  /* Note that in fact 0 and 1 are not prime */

  for(i=3;i<m;i++){
    for( j=2; j<i; j++)
      if(ary[ i ] && i%j==0){
	ary[i]=0; 
	break;
      }
  }
  for(i=0;i<m;i++)
    if(ary[i]) printf("%d ", i);
  free( ary );
  printf("\n");
}


int main() {
  int m;
  printf("m = ");
  scanf("%d", &m);
  printf("\n");
  print_prime(m);
  return 0;
}
